Jacobian {
  { Name Vol ;
    Case{
      { Region All ; Jacobian Vol ; }
    }
  }
}

Integration {
  { Name CurlCurl ;
    Case { 
      { Type Gauss ;
        Case {  
          { GeoElement Tetrahedron ; NumberOfPoints  4 ; }
        }
      }
    }
  }
}

Group {
  Omega = Region[100];
  Bdry  = Region[101];
}

Function {
  f[Omega] = Vector[1.0, 0.0, 0.0];
  g[Omega] = Vector[1.0, 0.0, 0.0];
}

Constraint {
  { Name DirichletBC; Type Assign;
    Case {
      { Region Bdry; Value g[]; }
    }
  }
}

FunctionSpace {
  { Name H0curl; Type Form1;
    BasisFunction {
      { Name phi_j; NameOfCoef U_j; Function BF_Edge;
        Support Omega; Entity EdgesOf[All]; }
    }
    Constraint {
      { NameOfCoef U_j; EntityType EdgesOf;
        NameOfConstraint DirichletBC; }
    }
  }
}

Formulation {
  { Name CurlSqr; Type FemEquation;
    Quantity {
      { Name uh; Type Local; NameOfSpace H0curl; }
    }
    Equation {
      Galerkin { [ Dof{uh}, {uh} ]; In Omega;
                 Jacobian Vol; Integration CurlCurl; }
      Galerkin { [ Dof{d uh}, {d uh} ] ; In Omega;
                 Jacobian Vol; Integration CurlCurl; }
      Galerkin { [ -f[], {uh} ]; In Omega;
                 Jacobian Vol; Integration CurlCurl; }
    }
  }
}

Resolution {
  { Name DiscreteBVP;
    System {
      { Name SysCurlSqr; NameOfFormulation CurlSqr; }
    }
    Operation {
      Generate[SysCurlSqr]; Solve[SysCurlSqr]; SaveSolution[SysCurlSqr];
    }
  }
}


PostProcessing {
  { Name DiscreteBVP; NameOfFormulation CurlSqr;
    Quantity {
      { Name uh;
        Value {
          Local { [ {uh} ]; In Omega; Jacobian Vol; }
        }
      }
    }
  }
}

PostOperation {
  { Name Map; NameOfPostProcessing DiscreteBVP;
    Operation {
      Print [ uh, OnElementsOf Omega, File "uh.pos"];
    }
  }
}

